/*----- PROTECTED REGION ID(PZ116EClass.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id: PZ116EClass.cpp,v 1.3 2015-08-27 14:51:04 giulio Exp $";
static const char *TagName    = "$Name: release_10 $";
static const char *CvsPath    = "$Source: /home/cvsadm/cvsroot/fermi/servers/pz116e/src/PZ116EClass.cpp,v $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        PZ116EClass.cpp
//
// description : C++ source for the PZ116EClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the name once per process.
//
// project :     PI Piezo PZ116E controller device server.
//
// $Author: giulio $
//
// $Revision: 1.3 $
// $Date: 2015-08-27 14:51:04 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/pz116e/src/PZ116EClass.cpp,v $
// $Log: PZ116EClass.cpp,v $
// Revision 1.3  2015-08-27 14:51:04  giulio
// Supported open-loop mode
//
// Revision 1.2  2012-06-07 09:57:21  giulio
// Added status strings, load waveform in init procedure
//
// Revision 1.1.1.1  2012-06-06 14:03:00  giulio
// First release
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <PZ116EClass.h>

/*----- PROTECTED REGION END -----*/	//	PZ116EClass.cpp

//-------------------------------------------------------------------
/**
 *	Create PZ116EClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_PZ116E_class(const char *name) {
		return PZ116E_ns::PZ116EClass::init(name);
	}
}

namespace PZ116E_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
PZ116EClass *PZ116EClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		PZ116EClass::PZ116EClass(string &s)
 * description : 	constructor for the PZ116EClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
PZ116EClass::PZ116EClass(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering PZ116EClass constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(PZ116EClass::constructor) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116EClass::constructor

	cout2 << "Leaving PZ116EClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		PZ116EClass::~PZ116EClass()
 * description : 	destructor for the PZ116EClass
 */
//--------------------------------------------------------
PZ116EClass::~PZ116EClass()
{
	/*----- PROTECTED REGION ID(PZ116EClass::destructor) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116EClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		PZ116EClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
PZ116EClass *PZ116EClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new PZ116EClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}		
	}		
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		PZ116EClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
PZ116EClass *PZ116EClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		ForwardClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ForwardClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "ForwardClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<PZ116E *>(device))->forward(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		BackwardClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *BackwardClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "BackwardClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<PZ116E *>(device))->backward(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		StopClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *StopClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "StopClass::execute(): arrived" << endl;
	((static_cast<PZ116E *>(device))->stop());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ResetClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ResetClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ResetClass::execute(): arrived" << endl;
	((static_cast<PZ116E *>(device))->reset());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		StartWaveformClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *StartWaveformClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "StartWaveformClass::execute(): arrived" << endl;
	((static_cast<PZ116E *>(device))->start_waveform());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		StopWaveformClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *StopWaveformClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "StopWaveformClass::execute(): arrived" << endl;
	((static_cast<PZ116E *>(device))->stop_waveform());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SendCmdClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SendCmdClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "SendCmdClass::execute(): arrived" << endl;
	Tango::DevString argin;
	extract(in_any, argin);
	return insert((static_cast<PZ116E *>(device))->send_cmd(argin));
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : PZ116EClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum PZ116EClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : PZ116EClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum PZ116EClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : PZ116EClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum PZ116EClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : PZ116EClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void PZ116EClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "InitCommand";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "SerialLine";
	prop_desc = "Linux serial device (ex: /dev/ttyS0)";
	prop_def  = "/dev/ttyS0";
	vect_data.clear();
	vect_data.push_back("/dev/ttyS0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Um2PsConvFactor";
	prop_desc = "Conversion factor ps =  Um2PsConvFactor * um";
	prop_def  = "1";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "TxRxSleep";
	prop_desc = "ms to sleep between tx and rx";
	prop_def  = "5000";
	vect_data.clear();
	vect_data.push_back("5000");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "ClosedLoop";
	prop_desc = "";
	prop_def  = "true";
	vect_data.clear();
	vect_data.push_back("true");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : PZ116EClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void PZ116EClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("PI Piezo PZ116E controller device server");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("PI Piezo PZ116E controller device server");
	description << str_desc;
	data.push_back(description);

	//	put cvs or svn location
	string	filename("PZ116E");
	filename += "Class.cpp";

	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : PZ116EClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void PZ116EClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(PZ116EClass::device_factory_before) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	PZ116EClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new PZ116E(this, (*devlist_ptr)[i]));							 
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		PZ116E *dev = static_cast<PZ116E *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(PZ116EClass::device_factory_after) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	PZ116EClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : PZ116EClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void PZ116EClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(PZ116EClass::attribute_factory_before) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	PZ116EClass::attribute_factory_before
	//	Attribute : RtMode
	RtModeAttrib	*rtmode = new RtModeAttrib();
	Tango::UserDefaultAttrProp	rtmode_prop;
	rtmode_prop.set_description("If enabled, do not readback position, do not check errors in mov command");
	//	label	not set for RtMode
	//	unit	not set for RtMode
	//	standard_unit	not set for RtMode
	//	display_unit	not set for RtMode
	//	format	not set for RtMode
	//	max_value	not set for RtMode
	//	min_value	not set for RtMode
	//	max_alarm	not set for RtMode
	//	min_alarm	not set for RtMode
	//	max_warning	not set for RtMode
	//	min_warning	not set for RtMode
	//	delta_t	not set for RtMode
	//	delta_val	not set for RtMode
	
	rtmode->set_default_properties(rtmode_prop);
	//	Not Polled
	rtmode->set_disp_level(Tango::OPERATOR);
	rtmode->set_memorized();
	rtmode->set_memorized_init(true);
	att_list.push_back(rtmode);

	//	Attribute : Position
	PositionAttrib	*position = new PositionAttrib();
	Tango::UserDefaultAttrProp	position_prop;
	//	description	not set for Position
	//	label	not set for Position
	position_prop.set_unit("um");
	//	standard_unit	not set for Position
	position_prop.set_display_unit("um");
	position_prop.set_format("%.4f");
	position_prop.set_max_value("999");
	position_prop.set_min_value("-999");
	//	max_alarm	not set for Position
	//	min_alarm	not set for Position
	//	max_warning	not set for Position
	//	min_warning	not set for Position
	//	delta_t	not set for Position
	//	delta_val	not set for Position
	
	position->set_default_properties(position_prop);
	//	Not Polled
	position->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(position);

	//	Attribute : IdentityNumber
	IdentityNumberAttrib	*identitynumber = new IdentityNumberAttrib();
	Tango::UserDefaultAttrProp	identitynumber_prop;
	//	description	not set for IdentityNumber
	//	label	not set for IdentityNumber
	//	unit	not set for IdentityNumber
	//	standard_unit	not set for IdentityNumber
	//	display_unit	not set for IdentityNumber
	//	format	not set for IdentityNumber
	//	max_value	not set for IdentityNumber
	//	min_value	not set for IdentityNumber
	//	max_alarm	not set for IdentityNumber
	//	min_alarm	not set for IdentityNumber
	//	max_warning	not set for IdentityNumber
	//	min_warning	not set for IdentityNumber
	//	delta_t	not set for IdentityNumber
	//	delta_val	not set for IdentityNumber
	
	identitynumber->set_default_properties(identitynumber_prop);
	//	Not Polled
	identitynumber->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(identitynumber);

	//	Attribute : OneshotWaveform
	OneshotWaveformAttrib	*oneshotwaveform = new OneshotWaveformAttrib();
	Tango::UserDefaultAttrProp	oneshotwaveform_prop;
	//	description	not set for OneshotWaveform
	//	label	not set for OneshotWaveform
	//	unit	not set for OneshotWaveform
	//	standard_unit	not set for OneshotWaveform
	//	display_unit	not set for OneshotWaveform
	//	format	not set for OneshotWaveform
	//	max_value	not set for OneshotWaveform
	//	min_value	not set for OneshotWaveform
	//	max_alarm	not set for OneshotWaveform
	//	min_alarm	not set for OneshotWaveform
	//	max_warning	not set for OneshotWaveform
	//	min_warning	not set for OneshotWaveform
	//	delta_t	not set for OneshotWaveform
	//	delta_val	not set for OneshotWaveform
	
	oneshotwaveform->set_default_properties(oneshotwaveform_prop);
	//	Not Polled
	oneshotwaveform->set_disp_level(Tango::OPERATOR);
	oneshotwaveform->set_memorized();
	oneshotwaveform->set_memorized_init(true);
	att_list.push_back(oneshotwaveform);

	//	Attribute : Stat
	StatAttrib	*stat = new StatAttrib();
	Tango::UserDefaultAttrProp	stat_prop;
	stat_prop.set_description("0) moving=true. not moving=false\n1) comm. error=true comm. ok=false\n");
	//	label	not set for Stat
	//	unit	not set for Stat
	//	standard_unit	not set for Stat
	//	display_unit	not set for Stat
	//	format	not set for Stat
	//	max_value	not set for Stat
	//	min_value	not set for Stat
	//	max_alarm	not set for Stat
	//	min_alarm	not set for Stat
	//	max_warning	not set for Stat
	//	min_warning	not set for Stat
	//	delta_t	not set for Stat
	//	delta_val	not set for Stat
	
	stat->set_default_properties(stat_prop);
	//	Not Polled
	stat->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(stat);

	//	Attribute : Waveform
	WaveformAttrib	*waveform = new WaveformAttrib();
	Tango::UserDefaultAttrProp	waveform_prop;
	//	description	not set for Waveform
	//	label	not set for Waveform
	waveform_prop.set_unit("um");
	//	standard_unit	not set for Waveform
	waveform_prop.set_display_unit("um");
	waveform_prop.set_format("%.4f");
	waveform_prop.set_max_value("999");
	waveform_prop.set_min_value("-999");
	//	max_alarm	not set for Waveform
	//	min_alarm	not set for Waveform
	//	max_warning	not set for Waveform
	//	min_warning	not set for Waveform
	//	delta_t	not set for Waveform
	//	delta_val	not set for Waveform
	
	waveform->set_default_properties(waveform_prop);
	//	Not Polled
	waveform->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(waveform);

	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(PZ116EClass::attribute_factory_after) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	PZ116EClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : PZ116EClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void PZ116EClass::command_factory()
{
	/*----- PROTECTED REGION ID(PZ116EClass::command_factory_before) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116EClass::command_factory_before


	//	Command Forward
	ForwardClass	*pForwardCmd =
		new ForwardClass("Forward",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pForwardCmd);

	//	Command Backward
	BackwardClass	*pBackwardCmd =
		new BackwardClass("Backward",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pBackwardCmd);

	//	Command Stop
	StopClass	*pStopCmd =
		new StopClass("Stop",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pStopCmd);

	//	Command Reset
	ResetClass	*pResetCmd =
		new ResetClass("Reset",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pResetCmd);

	//	Command StartWaveform
	StartWaveformClass	*pStartWaveformCmd =
		new StartWaveformClass("StartWaveform",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pStartWaveformCmd);

	//	Command StopWaveform
	StopWaveformClass	*pStopWaveformCmd =
		new StopWaveformClass("StopWaveform",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pStopWaveformCmd);

	//	Command SendCmd
	SendCmdClass	*pSendCmdCmd =
		new SendCmdClass("SendCmd",
			Tango::DEV_STRING, Tango::DEV_STRING,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pSendCmdCmd);

	/*----- PROTECTED REGION ID(PZ116EClass::command_factory_after) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116EClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		PZ116EClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list 
 */
//--------------------------------------------------------
void PZ116EClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(PZ116EClass::create_static_att_list) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116EClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		PZ116EClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void PZ116EClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{	
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		PZ116E *dev = static_cast<PZ116E *> (dev_impl);
		
		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(PZ116EClass::erase_dynamic_attributes) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116EClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : PZ116EClass::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *PZ116EClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; it++)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(PZ116EClass::Additional Methods) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116EClass::Additional Methods
} //	namespace
