/*----- PROTECTED REGION ID(PZ116EClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        PZ116EClass.h
//
// description : Include for the PZ116EClass root class.
//               This class is the singleton class for.
//               the PZ116E device class..
//               It contains all properties and methods which the .
//               PZ116E requires only once e.g. the commands.
//
// project :     PI Piezo PZ116E controller device server.
//
// $Author: giulio $
//
// $Revision: 1.3 $
// $Date: 2015-08-27 14:51:04 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/pz116e/src/PZ116EClass.h,v $
// $Log: PZ116EClass.h,v $
// Revision 1.3  2015-08-27 14:51:04  giulio
// Supported open-loop mode
//
// Revision 1.2  2012-06-07 09:57:21  giulio
// Added status strings, load waveform in init procedure
//
// Revision 1.1.1.1  2012-06-06 14:03:00  giulio
// First release
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef PZ116ECLASS_H
#define PZ116ECLASS_H

#include <tango.h>
#include <PZ116E.h>

/*----- PROTECTED REGION END -----*/	//	PZ116EClass.h


namespace PZ116E_ns
{
/*----- PROTECTED REGION ID(PZ116EClass::classes for dynamic creation) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116EClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute RtMode class definition
class RtModeAttrib: public Tango::Attr
{
public:
	RtModeAttrib():Attr("RtMode",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~RtModeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PZ116E *>(dev))->read_RtMode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PZ116E *>(dev))->write_RtMode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PZ116E *>(dev))->is_RtMode_allowed(ty);}
};

//	Attribute Position class definition
class PositionAttrib: public Tango::Attr
{
public:
	PositionAttrib():Attr("Position",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~PositionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PZ116E *>(dev))->read_Position(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PZ116E *>(dev))->write_Position(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PZ116E *>(dev))->is_Position_allowed(ty);}
};

//	Attribute IdentityNumber class definition
class IdentityNumberAttrib: public Tango::Attr
{
public:
	IdentityNumberAttrib():Attr("IdentityNumber",
			Tango::DEV_STRING, Tango::READ) {};
	~IdentityNumberAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PZ116E *>(dev))->read_IdentityNumber(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PZ116E *>(dev))->is_IdentityNumber_allowed(ty);}
};

//	Attribute OneshotWaveform class definition
class OneshotWaveformAttrib: public Tango::Attr
{
public:
	OneshotWaveformAttrib():Attr("OneshotWaveform",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~OneshotWaveformAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PZ116E *>(dev))->read_OneshotWaveform(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PZ116E *>(dev))->write_OneshotWaveform(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PZ116E *>(dev))->is_OneshotWaveform_allowed(ty);}
};

//	Attribute Stat class definition
class StatAttrib: public Tango::SpectrumAttr
{
public:
	StatAttrib():SpectrumAttr("Stat",
			Tango::DEV_BOOLEAN, Tango::READ, 32) {};
	~StatAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PZ116E *>(dev))->read_Stat(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PZ116E *>(dev))->is_Stat_allowed(ty);}
};

//	Attribute Waveform class definition
class WaveformAttrib: public Tango::SpectrumAttr
{
public:
	WaveformAttrib():SpectrumAttr("Waveform",
			Tango::DEV_DOUBLE, Tango::READ_WRITE, 256) {};
	~WaveformAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PZ116E *>(dev))->read_Waveform(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PZ116E *>(dev))->write_Waveform(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PZ116E *>(dev))->is_Waveform_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command Forward class definition
class ForwardClass : public Tango::Command
{
public:
	ForwardClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ForwardClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ForwardClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PZ116E *>(dev))->is_Forward_allowed(any);}
};

//	Command Backward class definition
class BackwardClass : public Tango::Command
{
public:
	BackwardClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	BackwardClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~BackwardClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PZ116E *>(dev))->is_Backward_allowed(any);}
};

//	Command Stop class definition
class StopClass : public Tango::Command
{
public:
	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PZ116E *>(dev))->is_Stop_allowed(any);}
};

//	Command Reset class definition
class ResetClass : public Tango::Command
{
public:
	ResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ResetClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PZ116E *>(dev))->is_Reset_allowed(any);}
};

//	Command StartWaveform class definition
class StartWaveformClass : public Tango::Command
{
public:
	StartWaveformClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StartWaveformClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StartWaveformClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PZ116E *>(dev))->is_StartWaveform_allowed(any);}
};

//	Command StopWaveform class definition
class StopWaveformClass : public Tango::Command
{
public:
	StopWaveformClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopWaveformClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopWaveformClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PZ116E *>(dev))->is_StopWaveform_allowed(any);}
};

//	Command SendCmd class definition
class SendCmdClass : public Tango::Command
{
public:
	SendCmdClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SendCmdClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SendCmdClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PZ116E *>(dev))->is_SendCmd_allowed(any);}
};


/**
 *	The PZ116EClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  PZ116EClass : public Tango::DeviceClass
#else
class PZ116EClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(PZ116EClass::Additionnal DServer data members) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116EClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static PZ116EClass *init(const char *);
		static PZ116EClass *instance();
		~PZ116EClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		PZ116EClass(string &);
		static PZ116EClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	PZ116E_H
