/*----- PROTECTED REGION ID(PZ116EStateMachine.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: PZ116EStateMachine.cpp,v 1.3 2015-08-27 14:51:04 giulio Exp $";
//=============================================================================
//
// file :        PZ116EStateMachine.cpp
//
// description : C++ source for the PZ116E and its alowed
//               methods for commands and attributes
//
// project :     PI Piezo PZ116E controller device server.
//
// $Author: giulio $
//
// $Revision: 1.3 $
// $Date: 2015-08-27 14:51:04 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/pz116e/src/PZ116EStateMachine.cpp,v $
// $Log: PZ116EStateMachine.cpp,v $
// Revision 1.3  2015-08-27 14:51:04  giulio
// Supported open-loop mode
//
// Revision 1.2  2012-06-07 09:57:21  giulio
// Added status strings, load waveform in init procedure
//
// Revision 1.1.1.1  2012-06-06 14:03:00  giulio
// First release
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================



#include <PZ116E.h>
#include <PZ116EClass.h>

/*----- PROTECTED REGION END -----*/	//	PZ116E::PZ116EStateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  ON       |  
//  FAULT    |  
//  MOVING   |  
//  RUNNING  |  
//  INIT     |  


namespace PZ116E_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : PZ116E::is_RtMode_allowed()
 *	Description : Execution allowed for RtMode attribute
 */
//--------------------------------------------------------
bool PZ116E::is_RtMode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for RtMode attribute in Write access.
	/*----- PROTECTED REGION ID(PZ116E::RtModeStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116E::RtModeStateAllowed_WRITE

	//	Not any excluded states for RtMode attribute in read access.
	/*----- PROTECTED REGION ID(PZ116E::RtModeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PZ116E::RtModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PZ116E::is_Position_allowed()
 *	Description : Execution allowed for Position attribute
 */
//--------------------------------------------------------
bool PZ116E::is_Position_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Position attribute in Write access.
	/*----- PROTECTED REGION ID(PZ116E::PositionStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116E::PositionStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(PZ116E::PositionStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	PZ116E::PositionStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PZ116E::is_IdentityNumber_allowed()
 *	Description : Execution allowed for IdentityNumber attribute
 */
//--------------------------------------------------------
bool PZ116E::is_IdentityNumber_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for IdentityNumber attribute in read access.
	/*----- PROTECTED REGION ID(PZ116E::IdentityNumberStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PZ116E::IdentityNumberStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PZ116E::is_OneshotWaveform_allowed()
 *	Description : Execution allowed for OneshotWaveform attribute
 */
//--------------------------------------------------------
bool PZ116E::is_OneshotWaveform_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for OneshotWaveform attribute in Write access.
	/*----- PROTECTED REGION ID(PZ116E::OneshotWaveformStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116E::OneshotWaveformStateAllowed_WRITE

	//	Not any excluded states for OneshotWaveform attribute in read access.
	/*----- PROTECTED REGION ID(PZ116E::OneshotWaveformStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PZ116E::OneshotWaveformStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PZ116E::is_Stat_allowed()
 *	Description : Execution allowed for Stat attribute
 */
//--------------------------------------------------------
bool PZ116E::is_Stat_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Stat attribute in read access.
	/*----- PROTECTED REGION ID(PZ116E::StatStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PZ116E::StatStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PZ116E::is_Waveform_allowed()
 *	Description : Execution allowed for Waveform attribute
 */
//--------------------------------------------------------
bool PZ116E::is_Waveform_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Waveform attribute in Write access.
	/*----- PROTECTED REGION ID(PZ116E::WaveformStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116E::WaveformStateAllowed_WRITE

	//	Not any excluded states for Waveform attribute in read access.
	/*----- PROTECTED REGION ID(PZ116E::WaveformStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PZ116E::WaveformStateAllowed_READ
	return true;
}

//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : PZ116E::is_Forward_allowed()
 *	Description : Execution allowed for Forward attribute
 */
//--------------------------------------------------------
bool PZ116E::is_Forward_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT ||
		get_state()==Tango::RUNNING ||
		get_state()==Tango::INIT)
	{
	/*----- PROTECTED REGION ID(PZ116E::ForwardStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116E::ForwardStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PZ116E::is_Backward_allowed()
 *	Description : Execution allowed for Backward attribute
 */
//--------------------------------------------------------
bool PZ116E::is_Backward_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT ||
		get_state()==Tango::RUNNING ||
		get_state()==Tango::INIT)
	{
	/*----- PROTECTED REGION ID(PZ116E::BackwardStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116E::BackwardStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PZ116E::is_Stop_allowed()
 *	Description : Execution allowed for Stop attribute
 */
//--------------------------------------------------------
bool PZ116E::is_Stop_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::INIT)
	{
	/*----- PROTECTED REGION ID(PZ116E::StopStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116E::StopStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PZ116E::is_Reset_allowed()
 *	Description : Execution allowed for Reset attribute
 */
//--------------------------------------------------------
bool PZ116E::is_Reset_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::INIT)
	{
	/*----- PROTECTED REGION ID(PZ116E::ResetStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116E::ResetStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PZ116E::is_StartWaveform_allowed()
 *	Description : Execution allowed for StartWaveform attribute
 */
//--------------------------------------------------------
bool PZ116E::is_StartWaveform_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for StartWaveform command.
	/*----- PROTECTED REGION ID(PZ116E::StartWaveformStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116E::StartWaveformStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PZ116E::is_StopWaveform_allowed()
 *	Description : Execution allowed for StopWaveform attribute
 */
//--------------------------------------------------------
bool PZ116E::is_StopWaveform_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for StopWaveform command.
	/*----- PROTECTED REGION ID(PZ116E::StopWaveformStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116E::StopWaveformStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PZ116E::is_SendCmd_allowed()
 *	Description : Execution allowed for SendCmd attribute
 */
//--------------------------------------------------------
bool PZ116E::is_SendCmd_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::INIT)
	{
	/*----- PROTECTED REGION ID(PZ116E::SendCmdStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PZ116E::SendCmdStateAllowed
		return false;
	}
	return true;
}

}	//	End of namespace
