/*PROTECTED REGION ID(PZ116E::main.cpp) ENABLED START*/
static const char *RcsId = "$Id: main.cpp,v 1.2 2015-08-27 14:51:04 giulio Exp $";
//=============================================================================
//
// file :        PZ116E.cpp
//
// description : C++ source for the PZ116E device server main.
//               The main rule is to initialise (and create) the Tango
//               system and to create the DServerClass singleton.
//                The main should be the same for every Tango device server.
//
// project :     PI Piezo PZ116E controller device server.
//
// $Author: giulio $
//
// $Revision: 1.2 $
// $Date: 2015-08-27 14:51:04 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/pz116e/src/main.cpp,v $
// $Log: main.cpp,v $
// Revision 1.2  2015-08-27 14:51:04  giulio
// Supported open-loop mode
//
// Revision 1.1.1.1  2012-06-06 14:03:00  giulio
// First release
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <tango.h>


int main(int argc,char *argv[])
{
	Tango::Util *tg = NULL;
	try
	{
		// Initialise the device server
		//----------------------------------------
		tg = Tango::Util::init(argc,argv);

		// Create the device server singleton 
		//	which will create everything
		//----------------------------------------
		tg->server_init(false);

		// Run the endless loop
		//----------------------------------------
		cout << "Ready to accept request" << endl;
		tg->server_run();
	}
	catch (bad_alloc)
	{
		cout << "Can't allocate memory to store device object !!!" << endl;
		cout << "Exiting" << endl;
	}
	catch (CORBA::Exception &e)
	{
		Tango::Except::print_exception(e);
		
		cout << "Received a CORBA_Exception" << endl;
		cout << "Exiting" << endl;
	}
	if (tg!=NULL)
		tg->server_cleanup();
	return(0);
}
/*PROTECTED REGION END*/	//	PZ116E::main.cpp
